#include <stdlib.h>
#include <sys/time.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <stdint.h>

#define FLAG_LEN                5

void seed_rng()
{
        struct timeval time;
        gettimeofday(&time, NULL);
        srand(time.tv_usec);
}

int mystery_func(int val)
{
	uint64_t res = val;
	uint64_t p1, p2;

	res = res * 0x30c30c31;
	p1 = res >> 32;

	p1 = p1 >> 3;

	res = p1;

	for (p2 = 0 ; p2 < 3; p2++) {
		res = res << 2;
		res += p1;
	}

	res = (res - p1) >> 1;


	return val - res;
}

int main()
{
	int i;
	seed_rng();
	for (i = 0; i < FLAG_LEN; i++) {
		int val = rand() % 1000;
		printf("mystery_func(%d) = ?\n", val);
		int res = mystery_func(val);
		int user_input;
		scanf("%d", &user_input);
		if (user_input == res) {
			printf("%d/%d Done\n", i + 1, FLAG_LEN);
		} else {
			printf("Wronnnnnnng!\n");
			return -1;
		}
	}
	printf("Congrats. The control panel is now open.\n");
	return 0;
}
